'\" t
.\" ** The above line should force tbl to be a preprocessor **
.\" Man page for atmail
.\"
.\" Copyright (C), 2004 Andreas Loesch
.\"
.\" You may distribute under the terms of the GNU General Public
.\" License as specified in the file COPYING.
.\"
.\" Mit Dec 22 16:00 MEST 2004, A. Loesch (software@andreasloesch.de)
.\"
.\"
.\" Convert: groff -Tps -man atmail.man > atmail.ps   
.\"          groff -Thtml -man atmail.man > atmail.html  
.\"          groff -Tlatin1 -man atmail.man | less    
.\"
.TH atmail 1 "Andreas Loesch" "December 23.12.2004" "attachment mailer version 0.4"
.SH NAME
atmail \- attachment mailer for bash (version 0.4)
.br
Copyright (c) 2004 
.br
by Andreas Loesch <software@andreasloesch.de>
.SH SYNOPSIS	
.B atmail
.RI [\| OPTIONS \|]\ 
.I RECIPIENT\-OPTIONS\ PARAMETER
.br
The parameter and switches are fully described in the appropriate sections later in 
this manual. In detail the shell script should be called like this:

.\" The with message command line
.B atmail
.RB [\| \-h \|]
.RB [\| \-v \|]
.RB [\| \-d \|]
.RB [\| \-s
.IR subject
.RB \|]
.RB [\| \-f
.IR sender
.RB \|]
.RB [\| \-a
.IR header
.RB \|]
.RB [\| \-e
.IR charset
.RB \|]
.IR <recipients>
.IR message
.RB [\|
.IR files .\|.\|.
.RB \|]

.\" The with stdin command line
.B atmail
.RB [\| \-h \|]
.RB [\| \-v \|]
.RB [\| \-d \|]
.RB [\| \-s
.IR subject
.RB \|]
.RB [\| \-f
.IR sender
.RB \|]
.RB [\| \-a
.IR header
.RB \|]
.RB [\| \-e
.IR charset
.RB \|]
.IR <recipients>
.IR -
.RB [\|
.IR files .\|.\|.
.RB \|]

and the 
.IR <recipients>
are given as comma seperated lists for the TO, CC and BCC recipients. Each recipient list 
switch can be used more than once.

.SH DESCRIPTION
.PP
.B atmail
is a small Bash-Script to send mails with binary attachments from the shell without other 
mail user agents. It is perfecty suited to be used inside administrative shell scripts. 
The Files are encoded as base64 so every modern MUA at the client-side should be able to 
decode them.
.PP
The basic idea was to build a very simple script alternative for mail or mailx with easy usage
of binary attachments. So I tried to allow all of the options you could use with mail or mailx.
.PP
When you use a script for administrative tasks like sending out monthly bills 
you don't want to show the recipient the real
user-Account you send this mail from, more often you want the client-side MUA to reply to
your invoice or sales office, so you can tell 
.B atmail
to use a different sender address in the From-line.
For the same reason you can add additional mail-header fields, like \(lq X-Bill-Number: 08/15 \(rq
.PP
There are no known limits for files you can attach (but don't use mail for excessively many or big files!)

.SH OPTIONS
.PP
The order of the options does not matter, you can mix them as you like. 
.TP
\fB\-h\fR
show the synopsis for
.BR atmail\|.
The execution is stopped after the output.
.TP
\fB\-v\fR
Verbose mode.
The details of
.B atmail
process are displayed on the user's terminal.
.TP
\fB\-d\fR
Dummy mode.
Execute normally but instead of piping the constructed Mail to
sendmail, send it to stdout. This flag is mainly for debugging purposes.
.TP
\fB\-s \fI subject\fR
Set the mailsubject to \fIsubject\fR. Use once, if the option is used more than one time
the last occurence is used for the mail. If you use whitespaces in the subjectline make 
sure to quote the parameter accordingly.
.TP
\fB\-f \fI sender\fR
Set the From-header to \fI sender\fR. Use once, if the option is used more than one time
the last occurence is used for the mail. If you use whitespaces in the address 
(e.g. My Office <office@domain.tld>)  make sure to quote the parameter accordingly.
.TP
\fB\-a \fI additional header\fR
Add an additional header to the mail. Use one switch per addtitional header. If you use 
whitespaces in the Header make sure to quote the parameter accordingly.
.TP
\fB\-e \fI encoding\fR
The message body is stored as \fIContent-Type: text/plain; charset=<ENCODING>\fR. The default 
\fI<ENCODING>\fR is us-ascii, this can be overwritten with the condiguration option (see CONFIGURATION) 
or with this switch. Make sure, your encoding will work, no checks are applied!

.SH RECIPIENT\-OPTIONS
The recipients of the Mail can be set by these option switches, according to the desired
recipient header in the mail (TO, CC, BCC). At least one address is mandatory, but you can
pass many addresses with comma seperated lists or with multiple switches. Each list can be used as
often as needed. If you want to use mailaddresses with Realnames (Name <name@domain.tld>) make
sure to use correct quoting.


.RB [\| \-t\|
\fI<TO\-recipientlist>\fR
.B ]

.RB [\| \-c
\fI<CC\-recipientlist>\fR
.B ]

.RB [\| \-b
\fI<BCC\-recipientlist>\fR
.B ]

and

\fIrecipientlist\fB := \fI<recipient>\fB |\fI ,\ <recipientlist>\fR

\fIrecipient\fB := \fI<mailaddress>\fB | \fR\(lq<\ \fI<mailaddress>\fR\ >\(rq

.in +9
.B |
\(lqRealname <\ \fI<mailaddress>\fR\ >\(rq
.in

.B mailaddress
is any correct emailaddress, that sendmail can use.

.SH PARAMETER
Together with one recipient the mail message ist mandatory. The attachments are not 
necessery but normally you use this script, if you want to send attachments :)
.TP
\fBmessage\fR or \fB\-\fR
The message body can be set on the commandline use quotes to protect the whitespaces or 
piped into the script via stdin. With \fB\-\fR as message text the script checks the stdin 
and uses the incomming text. You can also use \fB\-\fR without piping a message to the
script. In this case you will be prompted and can enter the Text manually.
.TP
\fBfiles\fR
All parameters after the message text will be treated as files that should be attached to
the mail. You can use absolute or relative paths. The files are checked with \fIfile\fR for 
their mime-type and encoded as base64 with \fIuuencode\fR.
.SH EXAMPLES
.TP
\fBatmail \-v \-t man@moon.org \-s \(lqlook at the pictures\(rq \(lqHi man in the moon, loot at these pix\(rq ~/sun.jpg ../fullmoon.png\fR
here we send a Mail with the subject \fIlook at the pictures\fR and the body \fIHi man in the moon, loot at these pix\fR to man@moon.org and attach two pictures. Each step is printed to stdout, because we used the verbose mode.
.TP
\fBatmail \-v \-t man@moon.org \-s \(lqlook at the pictures\(rq \(lqHi man in the moon, loot at these pix\(rq ~/sun.jpg ../fullmoon.png\fR
Here we use the \fI\-h\fR switch and print the synopsis to stdout. After this the script exits and all other parameter are discarded! You see also, the order of the sequence of switches does not matter. Only the message and the files have defined
positions.
.TP
\fBatmail -h\fR
.br
leeds to the same output as the previous examle.
.TP
\fBatmail -t \(lqFoo Bar <foo@bar.tld>,Tom <mail01@massmailer.org>\)rq -t paul@mary.com -c peter@mary.com "Hi there"\fR
sends a the mail to Foo Bar, Tom and paul and as cc to peter without attachments and an default subjectline
.TP
\fBatmail -t \(lqFoo Bar <foo@bar.tld>,Tom <mail01@massmailer.org>\)rq -f "Katie <office@mydomain.net>" "call me!"\fR
this mail is personalized, the sender is not the Unix-useraccount but Katie from the office...
.SH REQUIREMENTS
\fBatmail\fR needs some other tools to work properly. 
.TP 
\fBsendmail\fR
or a compatible mailer, important is, that the mailer can extract the recipients out of the
message. If your version needs switches to work in a sendmail compatible way, you can configure it 
with the \fISENDMAILOPS\fR
.TP
\fBuuencode\fR
to encode binary attachments.
.TP
\fBfile\fR
and also a default mime type database. \fBatmail\fR uses file to determine the mimetype of the
attachment to set the correct Content-Type in the mail message.
.SH CONFIGURATION
You can patch \fBatmail\fR to the local situation of your machine. In the first
place you should make sure that the paths to the needed executables are correct.
.TP
\fBTEMPPATH=\(lq/tmp\(rq\fR
the temporary directory
.TP
\fBSENDMAIL=\(lq/usr/sbin/sendmail\(rq\fR
the path to sendmail
.TP
\fBSENDMAILOPS=\fR
and possible options
.TP
\fBUUENCODE=\(lq/usr/bin/uuencode\(rq\fR
the path to uuencode
.TP
\fBFILE=\(lq/usr/bin/file\(rq\fR
the path to file (for mimetype)
.TP
\fBHOST=\fR
the message-id is constructed with the current date, time, the Process-id and the user-id
the domainpart is localhost or the host set here
.TP
\fBVERBOSE='=> '\fR
line-marker for verbose-Output
.TP
\fBCHARSET="us-ascii"\fR
the default charset for the message body, can be overwritten with \fB\-e charset\fR
.SH BUGS
.TP
\fBknown bugs\fR
\fBatmail\fR has no know bugs, only one minor problem that should be tweaked out in one of
the next releases. If you enter the message text interactively all empty lines are discarded, so if
you want to construct a mail with a well formatted text you should write it first and pipe it into
\fBatmail\fR.
.TP
\fBreport bugs or improvements \fR
If you discover new bugs or have other improvement ideas, send them as mail to the author.
.SH AUTHOR
.PP 
Andreas Loesch, mailto:software@andreasloesch.de
.SH COPYRIGHT and LICENSE
.PP
\fBatmail\fR \- attachment mailer for the bash
.br
Copyright (c) 2004, Andreas Loesch
.PP
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.
.PP
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
.PP
You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
						

